diff --git a/backup/moodle2/restore_stepslib.php b/backup/moodle2/restore_stepslib.php
index 9e310f7..4f2fd2c 100644
--- a/backup/moodle2/restore_stepslib.php
+++ b/backup/moodle2/restore_stepslib.php
@@ -56,7 +56,7 @@ class restore_drop_cron_lock extends restore_execution_step {
 }
 
 /**
- * delete old directories and conditionally create backup_temp_ids table
+ * delete old directories and conditionally create backup_temp_ids cache
  */
 class restore_create_and_clean_temp_stuff extends restore_execution_step {
 
@@ -355,21 +355,18 @@ class restore_gradebook_structure_step extends restore_structure_step {
     protected function after_execute() {
         global $DB;
 
-        $conditions = array(
-            'backupid' => $this->get_restoreid(),
-            'itemname' => 'grade_item'//,
-            //'itemid'   => $itemid
-        );
-        $rs = $DB->get_recordset('backup_ids_temp', $conditions);
+        $id_cache = backup_muc_manager::get('grade_item');
+        $cache_items = $id_cache->get_store()->find_all();
 
         // We need this for calculation magic later on.
         $mappings = array();
 
-        if (!empty($rs)) {
-            foreach($rs as $grade_item_backup) {
+        if (!empty($cache_items)) {
+            foreach($cache_items as $grade_item_id) {
+                $grade_item_backup = (object) $id_cache->get($grade_item_id);
 
                 // Store the oldid with the new id.
-                $mappings[$grade_item_backup->itemid] = $grade_item_backup->newitemid;
+                $mappings[$grade_item_id] = $grade_item_backup->newitemid;
 
                 $updateobj = new stdclass();
                 $updateobj->id = $grade_item_backup->newitemid;
@@ -388,7 +385,6 @@ class restore_gradebook_structure_step extends restore_structure_step {
                 }
             }
         }
-        $rs->close();
 
         // We need to update the calculations for calculated grade items that may reference old
         // grade item ids using ##gi\d+##.
@@ -547,10 +543,11 @@ class restore_review_pending_block_positions extends restore_execution_step {
         global $DB;
 
         // Get all the block_position objects pending to match
-        $params = array('backupid' => $this->get_restoreid(), 'itemname' => 'block_position');
-        $rs = $DB->get_recordset('backup_ids_temp', $params, '', 'itemid, info');
+        $id_cache = backup_muc_manager::get('block_position');
+        $cache_items = $id_cache->get_store()->find_all();
         // Process block positions, creating them or accumulating for final step
-        foreach($rs as $posrec) {
+        foreach($cache_items as $pos_id) {
+            $posrec = $id_cache->get($pos_id);
             // Get the complete position object out of the info field.
             $position = backup_controller_dbops::decode_backup_temp_info($posrec->info);
             // If position is for one already mapped (known) contextid
@@ -562,7 +559,6 @@ class restore_review_pending_block_positions extends restore_execution_step {
                 $DB->insert_record('block_positions', $position);
             }
         }
-        $rs->close();
     }
 }
 
@@ -596,10 +592,11 @@ class restore_update_availability extends restore_execution_step {
         $dateoffset = $this->apply_date_offset(1) - 1;
 
         // Update all sections that were restored.
-        $params = array('backupid' => $this->get_restoreid(), 'itemname' => 'course_section');
-        $rs = $DB->get_recordset('backup_ids_temp', $params, '', 'newitemid');
+        $id_cache = backup_muc_manager::get('course_section');
+        $cache_items = $id_cache->get_store()->find_all();
         $sectionsbyid = null;
-        foreach ($rs as $rec) {
+        foreach ($cache_items as $rec_id) {
+            $rec = (object) $id_cache->get($rec_id);
             if (is_null($sectionsbyid)) {
                 $sectionsbyid = array();
                 foreach ($modinfo->get_section_info_all() as $section) {
@@ -620,12 +617,13 @@ class restore_update_availability extends restore_execution_step {
                         $this->get_courseid(), $this->get_logger(), $dateoffset);
             }
         }
-        $rs->close();
 
         // Update all modules that were restored.
-        $params = array('backupid' => $this->get_restoreid(), 'itemname' => 'course_module');
-        $rs = $DB->get_recordset('backup_ids_temp', $params, '', 'newitemid');
-        foreach ($rs as $rec) {
+        $id_cache = backup_muc_manager::get('course_module');
+        $cache_items = $id_cache->get_store()->find_all();
+
+        foreach ($cache_items as $rec_id) {
+            $rec = (object) $id_cache->get($rec_id);
             if (!array_key_exists($rec->newitemid, $modinfo->cms)) {
                 // If the module was not fully restored for some reason
                 // (e.g. due to an earlier error), skip it.
@@ -640,7 +638,6 @@ class restore_update_availability extends restore_execution_step {
                         $this->get_courseid(), $this->get_logger(), $dateoffset);
             }
         }
-        $rs->close();
     }
 }
 
@@ -671,10 +668,11 @@ class restore_process_course_modules_availability extends restore_execution_step
         // Do both modules and sections.
         foreach (array('module', 'section') as $table) {
             // Get all the availability objects to process.
-            $params = array('backupid' => $this->get_restoreid(), 'itemname' => $table . '_availability');
-            $rs = $DB->get_recordset('backup_ids_temp', $params, '', 'itemid, info');
+            $id_cache = backup_muc_manager::get('availability');
+            $cache_items = $id_cache->get_store()->find_all();
             // Process availabilities, creating them if everything matches ok.
-            foreach ($rs as $availrec) {
+            foreach ($cache_items as $availrec_id) {
+                $availrec = (object) $id_cache->get($availrec_id);
                 $allmatchesok = true;
                 // Get the complete legacy availability object.
                 $availability = backup_controller_dbops::decode_backup_temp_info($availrec->info);
@@ -703,7 +701,6 @@ class restore_process_course_modules_availability extends restore_execution_step
                         array('id' => $thingid));
             }
         }
-        $rs->close();
     }
 }
 
@@ -1634,18 +1631,22 @@ class restore_course_legacy_files_step extends restore_execution_step {
         global $DB;
 
         // Do a check for legacy files and skip if there are none.
-        $sql = 'SELECT count(*)
-                  FROM {backup_files_temp}
-                 WHERE backupid = ?
-                   AND contextid = ?
-                   AND component = ?
-                   AND filearea  = ?';
-        $params = array($this->get_restoreid(), $this->task->get_old_contextid(), 'course', 'legacy');
-
-        if ($DB->count_records_sql($sql, $params)) {
+        $cache = backup_muc_manager::get('file_temp');
+
+        $count = 0;
+        $oldcontextid = $this->task->get_old_contextid();
+        foreach($cache->get_store()->find_all() as $id) {
+            $data = $cache->get($id);
+            if ($data->contextid == $oldcontextid &&
+                $data->component == 'course' &&
+                $data->filearea == 'legacy')
+                $count++;
+        }
+
+        if ($count) {
             $DB->set_field('course', 'legacyfiles', 2, array('id' => $this->get_courseid()));
             restore_dbops::send_files_to_pool($this->get_basepath(), $this->get_restoreid(), 'course',
-                'legacy', $this->task->get_old_contextid(), $this->task->get_userid());
+                'legacy', $oldcontextid, $this->task->get_userid());
         }
     }
 }
@@ -3465,7 +3466,7 @@ abstract class restore_activity_structure_step extends restore_structure_step {
  * Structure step in charge of creating/mapping all the qcats and qs
  * by parsing the questions.xml file and checking it against the
  * results calculated by {@link restore_process_categories_and_questions}
- * and stored in backup_ids_temp
+ * and stored in backup ids cache
  */
 class restore_create_categories_and_questions extends restore_structure_step {
 
@@ -3666,21 +3667,48 @@ class restore_create_categories_and_questions extends restore_structure_step {
         global $DB;
 
         // First of all, recode all the created question_categories->parent fields
-        $qcats = $DB->get_records('backup_ids_temp', array(
-                     'backupid' => $this->get_restoreid(),
-                     'itemname' => 'question_category_created'));
-        foreach ($qcats as $qcat) {
-            $newparent = 0;
-            $dbcat = $DB->get_record('question_categories', array('id' => $qcat->newitemid));
+        $qcats_created_cache = backup_muc_manager::get('question_category_created');
+        $qcats_created = $qcats_created_cache->get_store()->find_all();
+
+        $qcats_cache = backup_muc_manager::get('question_category');
+
+        $categories = array();
+        $qcats2 = array();
+        foreach ($qcats_created as $qcat_id) {
+            $qcat = $qcats_created_cache->get($qcat_id);
+            $qcats2[$qcat_id] = $qcat;
+            $categories[$qcat['newitemid']] = 1;
+        }
+
+        if (empty($categories)) {
+            return;
+        }
+
+        list($sql, $params) = $DB->get_in_or_equal(array_keys($categories));
+        $rs = $DB->get_records_sql("SELECT * FROM {question_categories} WHERE id $sql", $params);
+
+        $dbcats = array();
+        foreach ($rs as $record) {
+            $dbcats[$record->id] = $record;
+        }
+
+        foreach ($qcats2 as $id => $qcat) {
+            $dbcat = $dbcats[$qcat['newitemid']];
+
             // Get new parent (mapped or created, so we look in quesiton_category mappings)
-            if ($newparent = $DB->get_field('backup_ids_temp', 'newitemid', array(
-                                 'backupid' => $this->get_restoreid(),
-                                 'itemname' => 'question_category',
-                                 'itemid'   => $dbcat->parent))) {
+            if ($newparent = $qcats_cache->get($dbcat->parent)) {
                 // contextids must match always, as far as we always include complete qbanks, just check it
-                $newparentctxid = $DB->get_field('question_categories', 'contextid', array('id' => $newparent));
+                $newparent_newitemid = $newparent['newitemid'];
+                if (isset($dbcats[$newparent_newitemid])) {
+                    $newparentctxid = $dbcats[$newparent_newitemid]->contextid;
+                } else {
+                    $newparentctxid = $DB->get_field('question_categories', 'contextid', array('id' => $newparent_newitemid));
+
+                    // Save to avoid requerying.
+                    $dbcats[$newparent_newitemid] = (object) array('contenxtid' => $newparentctxid);
+                }
                 if ($dbcat->contextid == $newparentctxid) {
-                    $DB->set_field('question_categories', 'parent', $newparent, array('id' => $dbcat->id));
+                    $DB->set_field('question_categories', 'parent', $newparent_newitemid, array('id' => $dbcat->id));
                 } else {
                     $newparent = 0; // No ctx match for both cats, no parent relationship
                 }
@@ -3692,18 +3720,18 @@ class restore_create_categories_and_questions extends restore_structure_step {
         }
 
         // Now, recode all the created question->parent fields
-        $qs = $DB->get_records('backup_ids_temp', array(
-                  'backupid' => $this->get_restoreid(),
-                  'itemname' => 'question_created'));
-        foreach ($qs as $q) {
+        $qn_created_cache = backup_muc_manager::get('question_created');
+        $qs = $qn_created_cache->get_store()->find_all();
+
+        $qn_cache = backup_muc_manager::get('question');
+
+        foreach ($qs as $q_id) {
+            $q = $qn_created_cache->get($q_id);
             $newparent = 0;
-            $dbq = $DB->get_record('question', array('id' => $q->newitemid));
+            $dbq = $DB->get_record('question', array('id' => $q['newitemid']));
             // Get new parent (mapped or created, so we look in question mappings)
-            if ($newparent = $DB->get_field('backup_ids_temp', 'newitemid', array(
-                                 'backupid' => $this->get_restoreid(),
-                                 'itemname' => 'question',
-                                 'itemid'   => $dbq->parent))) {
-                $DB->set_field('question', 'parent', $newparent, array('id' => $dbq->id));
+            if ($newparent = $qn_cache->get($dbq->parent)) {
+                $DB->set_field('question', 'parent', $newparent['newitemid'], array('id' => $dbq->id));
             }
         }
 
@@ -3726,20 +3754,25 @@ class restore_move_module_questions_categories extends restore_execution_step {
         global $DB;
 
         $contexts = restore_dbops::restore_get_question_banks($this->get_restoreid(), CONTEXT_MODULE);
+        $qn_cat_cache = backup_muc_manager::get('question_category');
+        $qn_cat_ids = $qn_cat_cache->get_store()->find_all();
+        $qn_cats = array();
+        foreach ($qn_cat_ids as $qn_cat_id) {
+            $qn_cats[$qn_cat_id] = $qn_cat_cache->get($qn_cat_id);
+        }
         foreach ($contexts as $contextid => $contextlevel) {
             // Only if context mapping exists (i.e. the module has been restored)
             if ($newcontext = restore_dbops::get_backup_ids_record($this->get_restoreid(), 'context', $contextid)) {
                 // Update all the qcats having their parentitemid set to the original contextid
-                $modulecats = $DB->get_records_sql("SELECT itemid, newitemid
-                                                      FROM {backup_ids_temp}
-                                                     WHERE backupid = ?
-                                                       AND itemname = 'question_category'
-                                                       AND parentitemid = ?", array($this->get_restoreid(), $contextid));
-                foreach ($modulecats as $modulecat) {
-                    $DB->set_field('question_categories', 'contextid', $newcontext->newitemid, array('id' => $modulecat->newitemid));
+                $modulecats = array();
+                foreach ($qn_cat_ids as $qn_cat_id) {
+                    if ($qn_cats[$qn_cat_id]['parentitemid'] != $contextid) {
+                        continue;
+                    }
+                    $DB->set_field('question_categories', 'contextid', $newcontext->newitemid, array('id' => $qn_cat_id));
                     // And set new contextid also in question_category mapping (will be
                     // used by {@link restore_create_question_files} later
-                    restore_dbops::set_backup_ids_record($this->get_restoreid(), 'question_category', $modulecat->itemid, $modulecat->newitemid, $newcontext->newitemid);
+                    restore_dbops::set_backup_ids_record($this->get_restoreid(), 'question_category', $qn_cat_id, $qn_cats[$qn_cat_id]['newitemid'], $newcontext->newitemid);
                 }
             }
         }
@@ -3767,42 +3800,58 @@ class restore_create_question_files extends restore_execution_step {
         $progress = $this->task->get_progress();
         $progress->start_progress($this->get_name(), \core\progress\base::INDETERMINATE);
 
-        // Parentitemids of question_createds in backup_ids_temp are the category it is in.
-        // MUST use a recordset, as there is no unique key in the first (or any) column.
-        $catqtypes = $DB->get_recordset_sql("SELECT DISTINCT bi.parentitemid AS categoryid, q.qtype as qtype
-                                               FROM {backup_ids_temp} bi
-                                               JOIN {question} q ON q.id = bi.newitemid
-                                              WHERE bi.backupid = ?
-                                                AND bi.itemname = 'question_created'
-                                           ORDER BY categoryid ASC", array($this->get_restoreid()));
-
-        $currentcatid = -1;
-        foreach ($catqtypes as $categoryid => $row) {
-            $qtype = $row->qtype;
-
-            // Check if we are in a new category.
-            if ($currentcatid !== $categoryid) {
-                // Report progress for each category.
-                $progress->progress();
-
-                if (!$qcatmapping = restore_dbops::get_backup_ids_record($this->get_restoreid(),
-                        'question_category', $categoryid)) {
-                    // Something went really wrong, cannot find the question_category for the question_created records.
-                    debugging('Error fetching target context for question', DEBUG_DEVELOPER);
-                    continue;
-                }
+        // The parentitemid in the cached object is the category the question is in.
+        $qn_created_cache = backup_muc_manager::get('question_created');
+        $qns_created_ids = $qn_created_cache->get_store()->find_all();
 
-                // Calculate source and target contexts.
-                $oldctxid = $qcatmapping->info->contextid;
-                $newctxid = $qcatmapping->parentitemid;
+        // Get the actual data and list of question ids to match.
+        $qns_created = array();
+        $qids = array();
+        foreach($qns_created_ids as $qn_created) {
+            $temp = $qn_created_cache->get($qn_created);
+            $qns_created[$temp['newitemid']] = $temp;
+            $qids[$temp['newitemid']] = $temp['newitemid'];
+        }
 
-                $this->send_common_files($oldctxid, $newctxid, $progress);
-                $currentcatid = $categoryid;
+        if (empty($qids)) {
+            $progress->end_progress();
+            return;
+        }
+
+        list($sql, $params) = $DB->get_in_or_equal($qids);
+        $questions_rs = $DB->get_recordset_sql("SELECT id, qtype FROM {question} WHERE id $sql", $params);
+
+        // Build an array of [categoryid][qtype]
+        $questions = array();
+        foreach($questions_rs as $question) {
+            $categoryid = $qns_created[$question->id]['parentitemid'];
+            if (!isset($questions[$categoryid])) {
+                $questions[$categoryid] = array();
             }
+            $questions[$categoryid][$question->qtype] = 1;
+        }
 
-            $this->send_qtype_files($qtype, $oldctxid, $newctxid, $progress);
+        foreach ($questions as $categoryid => $rows) {
+            // Report progress for each category.
+            $progress->progress();
+
+            if (!$qcatmapping = restore_dbops::get_backup_ids_record($this->get_restoreid(),
+                        'question_category', $categoryid)) {
+                // Something went really wrong, cannot find the question_category for the question_created records.
+                debugging('Error fetching target context for question', DEBUG_DEVELOPER);
+                continue;
+            }
+
+            // Calculate source and target contexts.
+            $oldctxid = $qcatmapping->info->contextid;
+            $newctxid = $qcatmapping->parentitemid;
+
+            $this->send_common_files($oldctxid, $newctxid, $progress);
+
+            foreach($rows as $qtype => $yesitsset) {
+                $this->send_qtype_files($qtype, $oldctxid, $newctxid, $progress);
+            }
         }
-        $catqtypes->close();
         $progress->end_progress();
     }
 
@@ -3888,12 +3937,12 @@ class restore_process_file_aliases_queue extends restore_execution_step {
         $fs = get_file_storage();
 
         // Load the queue.
-        $rs = $DB->get_recordset('backup_ids_temp',
-            array('backupid' => $this->get_restoreid(), 'itemname' => 'file_aliases_queue'),
-            '', 'info');
+        $id_cache = backup_muc_manager::get('file_aliases_queue');
+        $rs = $id_cache->get_store()->find_all();
 
         // Iterate over aliases in the queue.
-        foreach ($rs as $record) {
+        foreach ($rs as $rid) {
+            $record = (object) $id_cache->get($rid);
             $info = backup_controller_dbops::decode_backup_temp_info($record->info);
 
             // Try to pick a repository instance that should serve the alias.
@@ -3916,17 +3965,18 @@ class restore_process_file_aliases_queue extends restore_execution_step {
                 }
 
                 // Let's see if the referred source file was also included in the backup.
-                $candidates = $DB->get_recordset('backup_files_temp', array(
-                        'backupid' => $this->get_restoreid(),
-                        'contextid' => $reference['contextid'],
-                        'component' => $reference['component'],
-                        'filearea' => $reference['filearea'],
-                        'itemid' => $reference['itemid'],
-                    ), '', 'info, newcontextid, newitemid');
-
+                $cache_c = backup_muc_manager::get('files_temp');
+                $candidates = $cache_c->get_store()->find_all();
                 $source = null;
 
-                foreach ($candidates as $candidate) {
+                foreach ($candidates as $candidateid) {
+                    $candidate = $cache_c->get($candidateid);
+                    if ($candidate->contextid != $reference['contextid'] ||
+                        $candidate->component != $reference['component'] ||
+                        $candidate->filearea  != $reference['filearea'] ||
+                        $candidate->itemid    != $reference['itemid']) {
+                        continue;
+                    }
                     $candidateinfo = backup_controller_dbops::decode_backup_temp_info($candidate->info);
                     if ($candidateinfo->filename === $reference['filename']
                             and $candidateinfo->filepath === $reference['filepath']
@@ -4017,7 +4067,6 @@ class restore_process_file_aliases_queue extends restore_execution_step {
                 }
             }
         }
-        $rs->close();
     }
 
     /**
diff --git a/backup/moodle2/restore_subplugin.class.php b/backup/moodle2/restore_subplugin.class.php
index bf21779..204e22a 100644
--- a/backup/moodle2/restore_subplugin.class.php
+++ b/backup/moodle2/restore_subplugin.class.php
@@ -102,7 +102,7 @@ abstract class restore_subplugin {
      * To send ids pairs to backup_ids_table and to store them into paths
      *
      * This method will send the given itemname and old/new ids to the
-     * backup_ids_temp table, and, at the same time, will save the new id
+     * backup ids cache, and, at the same time, will save the new id
      * into the corresponding restore_path_element for easier access
      * by children. Also will inject the known old context id for the task
      * in case it's going to be used for restoring files later
diff --git a/backup/util/dbops/backup_controller_dbops.class.php b/backup/util/dbops/backup_controller_dbops.class.php
index 41ff9d3..0bddfe2 100644
--- a/backup/util/dbops/backup_controller_dbops.class.php
+++ b/backup/util/dbops/backup_controller_dbops.class.php
@@ -112,60 +112,6 @@ abstract class backup_controller_dbops extends backup_dbops {
         return $controller;
     }
 
-    public static function create_backup_ids_temp_table($backupid) {
-        global $CFG, $DB;
-        $dbman = $DB->get_manager(); // We are going to use database_manager services
-
-        $xmldb_table = new xmldb_table('backup_ids_temp');
-        $xmldb_table->add_field('id', XMLDB_TYPE_INTEGER, '10', null, XMLDB_NOTNULL, XMLDB_SEQUENCE, null);
-        // Set default backupid (not needed but this enforce any missing backupid). That's hackery in action!
-        $xmldb_table->add_field('backupid', XMLDB_TYPE_CHAR, 32, null, XMLDB_NOTNULL, null, $backupid);
-        $xmldb_table->add_field('itemname', XMLDB_TYPE_CHAR, 160, null, XMLDB_NOTNULL, null, null);
-        $xmldb_table->add_field('itemid', XMLDB_TYPE_INTEGER, 10, null, XMLDB_NOTNULL, null, null);
-        $xmldb_table->add_field('newitemid', XMLDB_TYPE_INTEGER, 10, null, XMLDB_NOTNULL, null, '0');
-        $xmldb_table->add_field('parentitemid', XMLDB_TYPE_INTEGER, 10, null, null, null, null);
-        $xmldb_table->add_field('info', XMLDB_TYPE_TEXT, null, null, null, null, null);
-        $xmldb_table->add_key('primary', XMLDB_KEY_PRIMARY, array('id'));
-        $xmldb_table->add_key('backupid_itemname_itemid_uk', XMLDB_KEY_UNIQUE, array('backupid','itemname','itemid'));
-        $xmldb_table->add_index('backupid_parentitemid_ix', XMLDB_INDEX_NOTUNIQUE, array('backupid','itemname','parentitemid'));
-        $xmldb_table->add_index('backupid_itemname_newitemid_ix', XMLDB_INDEX_NOTUNIQUE, array('backupid','itemname','newitemid'));
-
-        $dbman->create_temp_table($xmldb_table); // And create it
-
-    }
-
-    public static function create_backup_files_temp_table($backupid) {
-        global $CFG, $DB;
-        $dbman = $DB->get_manager(); // We are going to use database_manager services
-
-        $xmldb_table = new xmldb_table('backup_files_temp');
-        $xmldb_table->add_field('id', XMLDB_TYPE_INTEGER, '10', null, XMLDB_NOTNULL, XMLDB_SEQUENCE, null);
-        // Set default backupid (not needed but this enforce any missing backupid). That's hackery in action!
-        $xmldb_table->add_field('backupid', XMLDB_TYPE_CHAR, 32, null, XMLDB_NOTNULL, null, $backupid);
-        $xmldb_table->add_field('contextid', XMLDB_TYPE_INTEGER, 10, null, XMLDB_NOTNULL, null, null);
-        $xmldb_table->add_field('component', XMLDB_TYPE_CHAR, 100, null, XMLDB_NOTNULL, null, null);
-        $xmldb_table->add_field('filearea', XMLDB_TYPE_CHAR, 50, null, XMLDB_NOTNULL, null, null);
-        $xmldb_table->add_field('itemid', XMLDB_TYPE_INTEGER, 10, null, XMLDB_NOTNULL, null, null);
-        $xmldb_table->add_field('info', XMLDB_TYPE_TEXT, null, null, null, null, null);
-        $xmldb_table->add_field('newcontextid', XMLDB_TYPE_INTEGER, 10, null, null, null, null);
-        $xmldb_table->add_field('newitemid', XMLDB_TYPE_INTEGER, 10, null, null, null, null);
-        $xmldb_table->add_key('primary', XMLDB_KEY_PRIMARY, array('id'));
-        $xmldb_table->add_index('backupid_contextid_component_filearea_itemid_ix', XMLDB_INDEX_NOTUNIQUE, array('backupid','contextid','component','filearea','itemid'));
-
-        $dbman->create_temp_table($xmldb_table); // And create it
-    }
-
-    public static function drop_backup_ids_temp_table($backupid) {
-        global $DB;
-        $dbman = $DB->get_manager(); // We are going to use database_manager services
-
-        $targettablename = 'backup_ids_temp';
-        if ($dbman->table_exists($targettablename)) {
-            $table = new xmldb_table($targettablename);
-            $dbman->drop_table($table); // And drop it
-        }
-    }
-
     /**
      * Decode the info field from backup_ids_temp or backup_files_temp.
      *
@@ -462,13 +408,19 @@ abstract class backup_controller_dbops extends backup_dbops {
     public static function backup_includes_mnet_remote_users($backupid) {
         global $CFG, $DB;
 
-        $sql = "SELECT COUNT(*)
-                  FROM {backup_ids_temp} b
-                  JOIN {user} u ON u.id = b.itemid
-                 WHERE b.backupid = ?
-                   AND b.itemname = 'userfinal'
-                   AND u.mnethostid != ?";
-        $count = $DB->count_records_sql($sql, array($backupid, $CFG->mnet_localhost_id));
+        $cache = backup_muc_manager::get('userfinal');
+        $cache_content = $cache->get_store()->find_all();
+
+        if (empty($cache_content)) {
+            return 0;
+        }
+
+        list($sql, $params) = $DB->get_in_or_equal($cache_content);
+        $params[] = $CFG->mnet_localhost_id;
+        $sql = "SELECT COUNT(*) FROM {user} u
+                               WHERE u.id $sql
+                                 AND u.mnethostid != ?";
+        $count = $DB->count_records_sql($sql, $params);
         return (int)(bool)$count;
     }
 
@@ -505,15 +457,19 @@ abstract class backup_controller_dbops extends backup_dbops {
     public static function backup_includes_file_references($backupid) {
         global $CFG, $DB;
 
+        $cache = backup_muc_manager::get('filefinal');
+        $fileids = $cache->get_store()->find_all();
+        if (empty($fileids)) {
+            return 0;
+        }
+
+        list($sql, $params) = $DB->get_in_or_equal($fileids);
         $sql = "SELECT count(r.repositoryid)
                   FROM {files} f
                   LEFT JOIN {files_reference} r
                        ON r.id = f.referencefileid
-                  JOIN {backup_ids_temp} bi
-                       ON f.id = bi.itemid
-                 WHERE bi.backupid = ?
-                       AND bi.itemname = 'filefinal'";
-        $count = $DB->count_records_sql($sql, array($backupid));
+                 WHERE f.id $sql";
+        $count = $DB->count_records_sql($sql, $params);
         return (int)(bool)$count;
     }
 
diff --git a/backup/util/dbops/backup_plan_dbops.class.php b/backup/util/dbops/backup_plan_dbops.class.php
index 5307637..3bbc261 100644
--- a/backup/util/dbops/backup_plan_dbops.class.php
+++ b/backup/util/dbops/backup_plan_dbops.class.php
@@ -261,18 +261,27 @@ abstract class backup_plan_dbops extends backup_dbops {
     public static function require_gradebook_backup($courseid, $backupid) {
         global $DB;
 
-        $sql = "SELECT count(id)
-                  FROM {grade_items}
-                 WHERE courseid=:courseid
-                   AND itemtype = 'mod'
-                   AND id NOT IN (
-                       SELECT bi.itemid
-                         FROM {backup_ids_temp} bi
-                        WHERE bi.itemname = 'grade_itemfinal'
-                          AND bi.backupid = :backupid)";
-        $params = array('courseid'=>$courseid, 'backupid'=>$backupid);
+        $cache = backup_muc_manager::get('grade_itemfinal');
 
+        $itemids = array();
+        foreach($cache->get_store()->find_all() as $id) {
+            $item = $cache->get($id);
+            $itemids[$id] = $id;
+        }
 
+        if (empty($itemids)) {
+            $sql = '< 0';
+            $params = array();
+        } else {
+            list($sql, $params) = $DB->get_in_or_equal($itemids, SQL_PARAMS_QM, 'param', false);
+        }
+        $params[] = $courseid;
+
+        $sql = "SELECT count(id)
+                  FROM {grade_items}
+                 WHERE itemtype = 'mod'
+                   AND id $sql
+                   AND courseid= ?";
         $count = $DB->count_records_sql($sql, $params);
 
         //if there are 0 activity grade items not already included in the backup
